﻿;;;-*- Mode: Lisp; Package: "UTC-MUL-1" -*-
;;;===============================================================================
;;;09/06/06
;;;                AGENT UTC-MUL-1
;;;
;;;===============================================================================

#|
2009
 0606 prefixing agent names with UTC-
|#

(defpackage :UTC-MUL-1 (:use :omas :cl #+MCL :ccl))
(in-package :UTC-MUL-1)

;;;===============================================================================
;;;                                  Agent
;;;===============================================================================

(omas::defagent :UTC-MUL-1 :redefine t)

;;;===============================================================================
;;;                                  Skills
;;;===============================================================================

(defskill :multiply :UTC-MUL-1
  :static-fcn static-multiply
  :how-long-fcn static-multiply-how-long
  :preconditions static-multiply-preconditions
  )

(defun static-multiply (agent message n1 n2)
  (declare (ignore message))
  (sleep (1+ (random 2)))
  (static-exit agent (* n1 n2)))

(defun static-multiply-preconditions (agent message n1 n2)
  (declare (ignore  agent message))
  (if (or (> n1 1000)(> n2 1000))
    (progn
      (format t "~& **** UTC-MUL-1 can't compute args too big ~S, ~S" n1 n2)
      nil)
    t))

(defun static-multiply-how-long (&rest ll)
  "UTC-MUL-1 has a computing time between 1 and 3 seconds."
  (declare (ignore ll))
  (1+ (random 2)))

:EOF